% ------------------------------------------------------------------------------
% Copyright (c) 2019, 2025 Contributors to the Eclipse Foundation
%
% See the NOTICE file(s) distributed with this work for additional
% information regarding copyright ownership.
%
% This program and the accompanying materials are made available under the terms
% of the MIT License which is available at https://opensource.org/licenses/MIT
%
% SPDX-License-Identifier: MIT
% ------------------------------------------------------------------------------
\documentclass{article}
\usepackage{tikz}
\usetikzlibrary{arrows.meta, arrows, automata, positioning, shapes, shapes.misc}
\usepackage[paperwidth=40in, paperheight=20in]{geometry}

\begin{document}
\pagestyle{empty}

\begin{tikzpicture}[
    auto,
    ->,
    node distance=3.5cm,
    every state/.style={ellipse, semithick, fill=black!5, minimum size=1.5cm, font=\Large},
    initial distance=1.2cm,
    every initial by arrow/.style={-{Stealth[scale=1.4]}},
    initial text=,
    transform shape,
    double distance=2pt,
    every loop/.style={min distance=10mm}
]

\node[state, initial]    (A) {$0$};
\node[state, right of=A] (B) {$1$};
\node[state, right of=B] (C) {$2$};
\node[state, right of=C] (D) {$3$};
\node[state, right of=D] (E) {$4$};

\path[-{Stealth[scale=1.4]}]
    (A) edge[bend left,above] node[align=center,above] {\texttt{ship\_enters}} (B)
    (B) edge[bend left,above] node[align=center,above] {\texttt{ship\_enters}} (C)
    (C) edge[bend left,above] node[align=center,above] {\texttt{ship\_enters}} (D)
    (D) edge[bend left,above] node[align=center,above] {\texttt{ship\_enters}} (E)
    (B) edge[bend left,below] node[align=center,below] {\texttt{ship\_leaves}} (A)
    (C) edge[bend left,below] node[align=center,below] {\texttt{ship\_leaves}} (B)
    (D) edge[bend left,below] node[align=center,below] {\texttt{ship\_leaves}} (C)
    (E) edge[bend left,below] node[align=center,below] {\texttt{ship\_leaves}} (D);
;

\end{tikzpicture}
\end{document}
